Subject: RE: bug#45428: 27.1; (quote (quote (quote ...))) unexpectedly works as anonymous face

From: Drew Adams <[email-masked]>
Date: Sat, 26 Dec 2020 20:47:01 -0800 (PST)

> I think it makes sense to be forgiving here as this is something users will commonly configure. As long as it doesn't give inconsistent results (which doesn't seem to be the case) it is probably better to be liberal in what we accept. Also, if we change it now, user configurations will break without AFAICT a strong reason. So I'd tend to say keep what we have now.

> IMO, we should still not document this just in case we find a strong reason to change it later. But we could perhaps add a unit test for this with a comment explaining why we try to accept this for the time being. Or we just do nothing and close the bug as wontfix.

> Just my two cents.

My 2c differ.  To me this is just a bug, and should be
fixed.  The behavior should follow the doc.  More
importantly, it should follow the general behavior of
Lisp evaluation.  Why would we treat '''foo, '''''foo,
etc. the same as 'foo?  The answer is that we wouldn't,
generally, and we don't.

I see no advantage whatsoever in "being forgiving" here
- what's that about?  This is a bad precedent, and I
don't see any particular reason for it here.

By "particular", I mean what's special about such
"forgiveness" in the case of anonymous face sexps?  Why
create a special case?  And what's the advantage for
users?

The argument that this behavior is longstanding is a
stronger argument (because it's stronger than zero),
but my 2c says it's not particularly strong here.

Maybe there's a good argument for this odd treatment.
I haven't see one so far.